<template>
<v-dialog :value="value" @input="$emit('input')" persistent scrollable max-width="500px">
  <v-card :loading="loadingFields">
  <v-card-text class="pop"> 
    <st-title text="Datos del coordinador"/>
    <st-alert
      v-if="alert.type"
      :text="alert.text"
      :type="alert.type"
    />
      <v-form
        ref="form"
        v-model="valid"
      >
      <div class="fields">
        <v-text-field
          v-for="(field, index) in fields"
          v-model="field.value"
          :counter="field.counter"
          :rules="field.rules"
          :label="field.label"
          :type="field.type"          
          :key="index"
          :disabled="index != 'correo' && !newUser"
          v-on:keyup.enter="index == 'correo' ? verifyEmail(field.value,field.rules) : ''"
          required
        />
      </div>
      <div class="content-footer">
        <st-secondary-btn 
          nombre="Cancelar" 
          @click="$emit('input')"
        />
        <st-primary-btn
          nombre = "Registrar coordinador"
          @click="register"
          :disable="!valid"
          :loading="loadingPost"
        />
      </div>
      </v-form>
    </v-card-text>
  </v-card>
</v-dialog>
</template>
<script>
export default {
  props:['value'],
  data () {
    return{
      fields:{
        correo:{
          value:'',
          label: 'Correo electrónico',
          counter: '',
          rules: [
              v => !!v || 'El e-mail es requerido',
              v => /.+@.+\..+/.test(v) || 'El correo debe ser valido',
          ],
        },
        codigo:{
          value:'',
          type: 'number',
          label: 'Código',
          counter: '8',
          rules: [
              v => !!v || 'El codigo es requerido',
              v => (v && v.length <= 8) || 'El código debe tener menos de 8 caracteres.',
          ],
        },
        nombres:{
          value:'',
          label: 'Nombres',
          counter: '150',
          rules: [
              v => !!v || 'El nombre es requerido',
              v => (v && v.length <= 150) || 'El nombre debe tener menos de 150 caracteres.',
          ],
        },
        apellidoPat:{
          value:'',
          label: 'Apellido paterno',
          counter: '150',
          rules: [
              v => !!v || 'El apellido materno es requerido',
              v => (v && v.length <= 150) || 'El apellido debe tener menos de 150 caracteres.',
          ],
        },
        apellidoMat:{
          value:'',
          label: 'Apellido materno',
          counter: '150',
          rules: [
              v => !!v || 'El apellido materno es requerido',
              v => (v && v.length <= 150) || 'El apellido debe tener menos de 150 caracteres.',
          ],
        },
        telefono:{
          value:'',
          type: 'number',
          label: 'Teléfono',
          counter: '9',
          rules: [
              v => (v.length <= 9) || 'El teléfono debe tener menos de 9 caracteres.',
          ],
        }
      },
      valid: false,
      loadingFields: false,
      loadingPost: false,
      newUser: false,
      fixedEmail: '',
      alert:{
        text: '',
        type: '',
      },
    }
  },
  watch: {
    'fields.correo.value'(newVal){
      if (newVal != this.fixedEmail) {
        this.cleanFields()
        this.newUser = false
      }
    }
  },
  methods:{
    cleanFields(){
      let {correo, ...fields} = this.fields
      for (let key in fields) fields[key].value = ''
    },
    async verifyEmail(email, rules){
      let boolRules = rules.map((rule) => rule(email))
      let truthyRules = boolRules.filter((bool) => bool === !!bool);
      if (boolRules.length == truthyRules.length){
        this.loadingFields = true
        try{
          var {data: {message, data}} = await this.$api.verifyCoorEmail(email)
        } catch(e) {
          this.$store.commit('setError', e)
        }
        this.loadingFields = false
        this.alert.text = message
        if (data.usuarioExiste){
          this.fixedEmail = data.usuario.correo
          if(data.esCoordinador){
            //no se puede registrar
            this.cleanFields()
            this.newUser = false
            this.alert.type = "error"
          }else{
            //se llenan los campos
            this.newUser = false
            for (let key in data.usuario) this.fields[key].value = data.usuario[key]
            this.alert.type = "success"
          }
        }else{
          //se registra uno nuevo
          this.cleanFields()
          this.newUser = true
          this.alert.type = "success"
        }
      }
    },
    async register(){
      let field = this.fields
      let data = {
        'data': {
          'coordinador': {
            'correo':field.correo.value,
            'codigo':field.codigo.value,
            'nombres': field.nombres.value,
            'apellidoPat': field.apellidoPat.value,
            'apellidoMat': field.apellidoMat.value,
            'telefono': field.telefono.value,
          }
        }
      }
      this.loadingPost = true
      try{
        let response = await this.$api.addCoordinator(data)
        this.$emit('refresh',{ response: response})
      } catch(e) {
        this.$store.commit('setError', e)
      }
      this.loadingPost = false
    }
  }
}
</script>

<style scoped lang="scss"> 
/* scope for encapsulate css */
</style>

